/*-----copyright-----
 *     amy-studio - make development easier 
 *     web        : http://www.amy-studio.com
 *     taobao     : http://amy-studio.taobao.com
 *     qq(e_mail) : amystudio@qq.com
 *-----file info-----
 *     name       : beep_test.v
 *     author     : Yuphone Chang
 *     description: Tick sound, to test BEEP
 *----- version -----
 *     created    : 7.19, 2010
 *     version    : 1.0
 *     description: original version
 *
 *     modified   : 
 *     version    : 
 *     description: 
 *-------------------
 */

module beep_test(
  input            CLOCK_50,            // Global clock 
  output reg       BEEP,                // Buzzer
  output     [1:1] LED                  // LED[1]
);

//++++++++++++++++++++++++++++++++++++++
// Counter begins 
//++++++++++++++++++++++++++++++++++++++
reg [25:0] cnt;

always @ (posedge CLOCK_50)
  cnt <= cnt + 1'b1; 
//--------------------------------------
// Counter ends 
//--------------------------------------


//++++++++++++++++++++++++++++++++++++++
// Tick sound begins 
//++++++++++++++++++++++++++++++++++++++
wire timer1 = cnt[23];                   // Cycle = 2^24/50M = 0.335s
wire timer2 = cnt[25];                   // Cycle = 2^26/50M = 1.34s

//          __    __    __    __    __    __    __    __
// timer1  |  |__|  |__|  |__|  |__|  |__|  |__|  |__|  |__|
//          ___________             ___________
// timer2  |           |___________|           |___________|
//          __    __                __    __
// beep_en |  |__|  |______________|  |__|  |______________|
wire beep_en = timer1&timer2;

always @ (posedge CLOCK_50)
  if (beep_en)
    BEEP <= 0;                          // turn on BEEP
  else
    BEEP <= 1;                          // turn off BEEP  
//--------------------------------------
// Tick sound ends 
//--------------------------------------

assign LED = beep_en;

endmodule
